part of hakkit.hakk.builder.basic;

abstract class _OperatorClass{
  _ExpressionNode operator +(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'add');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator -(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'sub');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator /(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'div');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator *(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'mul');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator <(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'jl');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator >(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'jg');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator <=(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'jle');
    _expressionQueue.add(node);
    return node;
  }
  
  _ExpressionNode operator >=(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'jge');
    _expressionQueue.add(node);
    return node;
  }
  
  operator ==(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, 'je');
    _expressionQueue.add(node);
    return node;
  }
  
  /// Performs a logical AND operation.
  /// 
  /// Because of the way order of precedence is handled by Dart for the & 
  /// operator, each side of the operation should be wrapped in parens.
  /// 
  /// # Example
  ///      //wrap both sides in parens like so
  ///      core0 << (val(10) < core1) & (val(42) > core3);
  _ExpressionNode operator &(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, '&');
    _expressionQueue.add(node);
    return node;
  }
  
  /// Performs a logical OR operation.
  /// 
  /// Because of the way order of precedence is handled by Dart for the | 
  /// operator, each side of the operation should be wrapped in parens.
  /// 
  /// # Example
  ///      //wrap both sides in parens like so
  ///      core0 << (val(10) < core1) | (val(42) > core3);
  _ExpressionNode operator |(next){
    next = _wrapLiteral(next);
    final node = new _ExpressionNode(this, next, '|');
    _expressionQueue.add(node);
    return node;
  }
}